Imports System.IO

Public Class frmMain

    '**********************************************************************
    '*                    FORM-Level Variables                            *
    '**********************************************************************

    Private mstrPuzzle As String
    Private mstrKey As String = New String(" ", 26)
    Private mstrStrippedUserSolution As String
    Private mstrStrippedPuzzle As String
    Private mstrErrorMessage As String
    Private mastrPuzzles() As String

    Private mintNbrOfPuzzles As Integer
    Private mintLastPuzzle As Integer
    Private mintPuzzLen As Integer
    Private mintGamesPlayed As Integer
    Private mintGamesWon As Integer
    Private mintNewFocus As Integer
    Private mintCurrFocus As Integer

    Private mblnChangingViaCode As Boolean = True
    Private mblnSkipCheck As Boolean
    Private mblnGameInProgress As Boolean
    Private mblnLoadComplete As Boolean
    Private mblnUpOrDown As Boolean
    Private mblnHomeOrEnd As Boolean
    Private mblnAllBlank As Boolean

    Private mblnActivated As Boolean = False
    Private txtUserLetter As TextBox
    Private lblPuzzleLetter As Label

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        LoadGameData()
        mblnSkipCheck = True
        btnNewGame.PerformClick()

    End Sub

    Private Sub frmMain_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated

        If mblnActivated Then Exit Sub

        For intX As Integer = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                txtUserLetter.Focus()
                Exit For
            End If
        Next

        mblnActivated = True

    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim strFileName As String
        Dim objFS As FileStream
        Dim objSW As StreamWriter

        CheckForAllBlanks()

        If Not mblnAllBlank Then
            If mblnGameInProgress Then
                StripTheComparands()
                If mstrStrippedUserSolution = mstrStrippedPuzzle Then
                    mintGamesPlayed = mintGamesPlayed + 1
                    mintGamesWon = mintGamesWon + 1
                    lblStatusMsg.Text = "Games Won: " & CStr(mintGamesWon) _
                                      & " / Games Played: " _
                                      & CStr(mintGamesPlayed)
                    lblStatusMsg.Refresh()
                    MsgBox("Your solution is correct! ", , _
                           "Cryptogram Message")
                Else
                    If MsgBox("Your solution is either incorrect or incomplete. " _
                            & "Are you sure you want to quit and cancel the current game?", _
                              vbYesNo + vbQuestion, _
                              "Cryptogram Message") = vbNo Then
                        e.Cancel = True
                        Exit Sub
                    End If
                End If
            End If
        End If

        strFileName = My.Application.Info.DirectoryPath & "\LastPuzz.txt"
        objFS = New FileStream(strFileName, FileMode.Open, FileAccess.Write)
        objSW = New StreamWriter(objFS)
        objSW.WriteLine(CStr(mintLastPuzzle))
        objSW.Close()

    End Sub

    Private Sub frmMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        Dim intX As Integer

        Select Case e.KeyCode
            Case Keys.Up
                mintNewFocus = mintCurrFocus - 18
                GoUpOrDown()
            Case Keys.Down
                mintNewFocus = mintCurrFocus + 18
                GoUpOrDown()
            Case Keys.Home
                GoHomeOrEnd(Keys.Home)
            Case Keys.End
                GoHomeOrEnd(Keys.End)
            Case Keys.Right
                For intX = (mintCurrFocus + 1) To 89
                    txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                    If txtUserLetter.Visible Then
                        txtUserLetter.Focus()
                        Exit For
                    End If
                Next
            Case Keys.Left
                For intX = (mintCurrFocus - 1) To 0 Step -1
                    txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                    If txtUserLetter.Visible Then
                        txtUserLetter.Focus()
                        Exit For
                    End If
                Next
        End Select

    End Sub


    Private Sub txtUserLetter_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles txtUserLetter0.GotFocus, txtUserLetter1.GotFocus, txtUserLetter2.GotFocus, txtUserLetter3.GotFocus, txtUserLetter4.GotFocus, _
            txtUserLetter5.GotFocus, txtUserLetter6.GotFocus, txtUserLetter7.GotFocus, txtUserLetter8.GotFocus, txtUserLetter9.GotFocus, _
            txtUserLetter10.GotFocus, txtUserLetter11.GotFocus, txtUserLetter12.GotFocus, txtUserLetter13.GotFocus, txtUserLetter14.GotFocus, _
            txtUserLetter15.GotFocus, txtUserLetter16.GotFocus, txtUserLetter17.GotFocus, txtUserLetter18.GotFocus, txtUserLetter19.GotFocus, _
            txtUserLetter20.GotFocus, txtUserLetter21.GotFocus, txtUserLetter22.GotFocus, txtUserLetter23.GotFocus, txtUserLetter24.GotFocus, _
            txtUserLetter25.GotFocus, txtUserLetter26.GotFocus, txtUserLetter27.GotFocus, txtUserLetter28.GotFocus, txtUserLetter29.GotFocus, _
            txtUserLetter30.GotFocus, txtUserLetter31.GotFocus, txtUserLetter32.GotFocus, txtUserLetter33.GotFocus, txtUserLetter34.GotFocus, _
            txtUserLetter35.GotFocus, txtUserLetter36.GotFocus, txtUserLetter37.GotFocus, txtUserLetter38.GotFocus, txtUserLetter39.GotFocus, _
            txtUserLetter40.GotFocus, txtUserLetter41.GotFocus, txtUserLetter42.GotFocus, txtUserLetter43.GotFocus, txtUserLetter44.GotFocus, _
            txtUserLetter45.GotFocus, txtUserLetter46.GotFocus, txtUserLetter47.GotFocus, txtUserLetter48.GotFocus, txtUserLetter49.GotFocus, _
            txtUserLetter50.GotFocus, txtUserLetter51.GotFocus, txtUserLetter52.GotFocus, txtUserLetter53.GotFocus, txtUserLetter54.GotFocus, _
            txtUserLetter55.GotFocus, txtUserLetter56.GotFocus, txtUserLetter57.GotFocus, txtUserLetter58.GotFocus, txtUserLetter59.GotFocus, _
            txtUserLetter60.GotFocus, txtUserLetter61.GotFocus, txtUserLetter62.GotFocus, txtUserLetter63.GotFocus, txtUserLetter64.GotFocus, _
            txtUserLetter65.GotFocus, txtUserLetter66.GotFocus, txtUserLetter67.GotFocus, txtUserLetter68.GotFocus, txtUserLetter69.GotFocus, _
            txtUserLetter70.GotFocus, txtUserLetter71.GotFocus, txtUserLetter72.GotFocus, txtUserLetter73.GotFocus, txtUserLetter74.GotFocus, _
            txtUserLetter75.GotFocus, txtUserLetter76.GotFocus, txtUserLetter77.GotFocus, txtUserLetter78.GotFocus, txtUserLetter79.GotFocus, _
            txtUserLetter80.GotFocus, txtUserLetter81.GotFocus, txtUserLetter82.GotFocus, txtUserLetter83.GotFocus, txtUserLetter84.GotFocus, _
            txtUserLetter85.GotFocus, txtUserLetter86.GotFocus, txtUserLetter87.GotFocus, txtUserLetter88.GotFocus, txtUserLetter89.GotFocus

        txtUserLetter = DirectCast(sender, TextBox)

        If mblnUpOrDown Then
            mblnUpOrDown = False
            mintCurrFocus = mintNewFocus
            txtUserLetter.Focus()
            Exit Sub
        End If

        txtUserLetter.SelectAll()

        mintCurrFocus = CInt(Mid(sender.Name, 14))

    End Sub

    Private Sub txtUserLetter_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) _
    Handles txtUserLetter0.KeyPress, txtUserLetter1.KeyPress, txtUserLetter2.KeyPress, txtUserLetter3.KeyPress, txtUserLetter4.KeyPress, _
            txtUserLetter5.KeyPress, txtUserLetter6.KeyPress, txtUserLetter7.KeyPress, txtUserLetter8.KeyPress, txtUserLetter9.KeyPress, _
            txtUserLetter10.KeyPress, txtUserLetter11.KeyPress, txtUserLetter12.KeyPress, txtUserLetter13.KeyPress, txtUserLetter14.KeyPress, _
            txtUserLetter15.KeyPress, txtUserLetter16.KeyPress, txtUserLetter17.KeyPress, txtUserLetter18.KeyPress, txtUserLetter19.KeyPress, _
            txtUserLetter20.KeyPress, txtUserLetter21.KeyPress, txtUserLetter22.KeyPress, txtUserLetter23.KeyPress, txtUserLetter24.KeyPress, _
            txtUserLetter25.KeyPress, txtUserLetter26.KeyPress, txtUserLetter27.KeyPress, txtUserLetter28.KeyPress, txtUserLetter29.KeyPress, _
            txtUserLetter30.KeyPress, txtUserLetter31.KeyPress, txtUserLetter32.KeyPress, txtUserLetter33.KeyPress, txtUserLetter34.KeyPress, _
            txtUserLetter35.KeyPress, txtUserLetter36.KeyPress, txtUserLetter37.KeyPress, txtUserLetter38.KeyPress, txtUserLetter39.KeyPress, _
            txtUserLetter40.KeyPress, txtUserLetter41.KeyPress, txtUserLetter42.KeyPress, txtUserLetter43.KeyPress, txtUserLetter44.KeyPress, _
            txtUserLetter45.KeyPress, txtUserLetter46.KeyPress, txtUserLetter47.KeyPress, txtUserLetter48.KeyPress, txtUserLetter49.KeyPress, _
            txtUserLetter50.KeyPress, txtUserLetter51.KeyPress, txtUserLetter52.KeyPress, txtUserLetter53.KeyPress, txtUserLetter54.KeyPress, _
            txtUserLetter55.KeyPress, txtUserLetter56.KeyPress, txtUserLetter57.KeyPress, txtUserLetter58.KeyPress, txtUserLetter59.KeyPress, _
            txtUserLetter60.KeyPress, txtUserLetter61.KeyPress, txtUserLetter62.KeyPress, txtUserLetter63.KeyPress, txtUserLetter64.KeyPress, _
            txtUserLetter65.KeyPress, txtUserLetter66.KeyPress, txtUserLetter67.KeyPress, txtUserLetter68.KeyPress, txtUserLetter69.KeyPress, _
            txtUserLetter70.KeyPress, txtUserLetter71.KeyPress, txtUserLetter72.KeyPress, txtUserLetter73.KeyPress, txtUserLetter74.KeyPress, _
            txtUserLetter75.KeyPress, txtUserLetter76.KeyPress, txtUserLetter77.KeyPress, txtUserLetter78.KeyPress, txtUserLetter79.KeyPress, _
            txtUserLetter80.KeyPress, txtUserLetter81.KeyPress, txtUserLetter82.KeyPress, txtUserLetter83.KeyPress, txtUserLetter84.KeyPress, _
            txtUserLetter85.KeyPress, txtUserLetter86.KeyPress, txtUserLetter87.KeyPress, txtUserLetter88.KeyPress, txtUserLetter89.KeyPress

        Dim intX As Integer
        Dim intCurrIndex As Integer

        intCurrIndex = CInt(Mid(sender.Name, 14))

        ResetForm()

        e.Handled = Not (Char.IsLetter(e.KeyChar) Or Asc(e.KeyChar) < 32)
        If e.Handled Then Exit Sub


        lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intCurrIndex), Label)
        If UCase(e.KeyChar) = lblPuzzleLetter.Text Then
            e.Handled = True
            Exit Sub
        End If

        For intX = 0 To 89
            If intX <> intCurrIndex Then
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    If txtUserLetter.Text = UCase(e.KeyChar) Then
                        e.Handled = True
                        Exit For
                    End If
                End If
            End If
        Next

    End Sub

    Private Sub txtUserLetter_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles txtUserLetter0.TextChanged, txtUserLetter1.TextChanged, txtUserLetter2.TextChanged, txtUserLetter3.TextChanged, txtUserLetter4.TextChanged, _
            txtUserLetter5.TextChanged, txtUserLetter6.TextChanged, txtUserLetter7.TextChanged, txtUserLetter8.TextChanged, txtUserLetter9.TextChanged, _
            txtUserLetter10.TextChanged, txtUserLetter11.TextChanged, txtUserLetter12.TextChanged, txtUserLetter13.TextChanged, txtUserLetter14.TextChanged, _
            txtUserLetter15.TextChanged, txtUserLetter16.TextChanged, txtUserLetter17.TextChanged, txtUserLetter18.TextChanged, txtUserLetter19.TextChanged, _
            txtUserLetter20.TextChanged, txtUserLetter21.TextChanged, txtUserLetter22.TextChanged, txtUserLetter23.TextChanged, txtUserLetter24.TextChanged, _
            txtUserLetter25.TextChanged, txtUserLetter26.TextChanged, txtUserLetter27.TextChanged, txtUserLetter28.TextChanged, txtUserLetter29.TextChanged, _
            txtUserLetter30.TextChanged, txtUserLetter31.TextChanged, txtUserLetter32.TextChanged, txtUserLetter33.TextChanged, txtUserLetter34.TextChanged, _
            txtUserLetter35.TextChanged, txtUserLetter36.TextChanged, txtUserLetter37.TextChanged, txtUserLetter38.TextChanged, txtUserLetter39.TextChanged, _
            txtUserLetter40.TextChanged, txtUserLetter41.TextChanged, txtUserLetter42.TextChanged, txtUserLetter43.TextChanged, txtUserLetter44.TextChanged, _
            txtUserLetter45.TextChanged, txtUserLetter46.TextChanged, txtUserLetter47.TextChanged, txtUserLetter48.TextChanged, txtUserLetter49.TextChanged, _
            txtUserLetter50.TextChanged, txtUserLetter51.TextChanged, txtUserLetter52.TextChanged, txtUserLetter53.TextChanged, txtUserLetter54.TextChanged, _
            txtUserLetter55.TextChanged, txtUserLetter56.TextChanged, txtUserLetter57.TextChanged, txtUserLetter58.TextChanged, txtUserLetter59.TextChanged, _
            txtUserLetter60.TextChanged, txtUserLetter61.TextChanged, txtUserLetter62.TextChanged, txtUserLetter63.TextChanged, txtUserLetter64.TextChanged, _
            txtUserLetter65.TextChanged, txtUserLetter66.TextChanged, txtUserLetter67.TextChanged, txtUserLetter68.TextChanged, txtUserLetter69.TextChanged, _
            txtUserLetter70.TextChanged, txtUserLetter71.TextChanged, txtUserLetter72.TextChanged, txtUserLetter73.TextChanged, txtUserLetter74.TextChanged, _
            txtUserLetter75.TextChanged, txtUserLetter76.TextChanged, txtUserLetter77.TextChanged, txtUserLetter78.TextChanged, txtUserLetter79.TextChanged, _
            txtUserLetter80.TextChanged, txtUserLetter81.TextChanged, txtUserLetter82.TextChanged, txtUserLetter83.TextChanged, txtUserLetter84.TextChanged, _
            txtUserLetter85.TextChanged, txtUserLetter86.TextChanged, txtUserLetter87.TextChanged, txtUserLetter88.TextChanged, txtUserLetter89.TextChanged

        Dim intX As Integer
        Dim intCurrIndex As Integer
        Dim blnFocusWasSet As Boolean
        Dim lblPuzzleLetterCurr As Label
        Dim txtUserLetterCurr As TextBox

        If mblnChangingViaCode Then Exit Sub

        intCurrIndex = CInt(Mid(sender.Name, 14))

        For intX = 0 To 89
            If intX <> intCurrIndex Then
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intX), Label)
                    lblPuzzleLetterCurr = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intCurrIndex), Label)
                    txtUserLetterCurr = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intCurrIndex), TextBox)
                    If lblPuzzleLetter.Text = lblPuzzleLetterCurr.Text Then
                        txtUserLetter.Text = txtUserLetterCurr.Text
                    End If
                End If
            End If
        Next

        txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intCurrIndex), TextBox)
        If Trim(txtUserLetter.Text) = "" Then Exit Sub

        For intX = (intCurrIndex + 1) To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                If Trim(txtUserLetter.Text) = "" Then
                    txtUserLetter.Focus()
                    blnFocusWasSet = True
                    Exit For
                End If
            End If
        Next

        If blnFocusWasSet Then Exit Sub

        For intX = 0 To intCurrIndex
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                If Trim$(txtUserLetter.Text) = "" Then
                    txtUserLetter.Focus()
                    Exit For
                End If
            End If
        Next

    End Sub

    Private Sub btnInstructions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInstructions.Click
        frmHelp.ShowDialog()
    End Sub

    Private Sub btnCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck.Click

        Dim intX As Integer

        CheckForAllBlanks()
        If mblnAllBlank Then
            MsgBox("There's nothing to check!", vbExclamation, _
                    "Cryptogram Message")
            Exit Sub
        End If

        StripTheComparands()
        If mstrStrippedUserSolution = mstrStrippedPuzzle Then
            mintGamesPlayed = mintGamesPlayed + 1
            mintGamesWon = mintGamesWon + 1
            lblStatusMsg.Text = "Games Won: " & CStr(mintGamesWon) _
                              & " / Games Played: " & CStr(mintGamesPlayed)
            lblStatusMsg.Refresh()
            If MsgBox("Your solution is correct! " _
                    & "Do you want to play again?", _
                      vbYesNo + vbQuestion, "Cryptogram Message") = vbYes _
            Then
                mblnSkipCheck = True
                btnNewGame.PerformClick()
                Exit Sub
            Else
                mblnGameInProgress = False
                Me.Close()
                Exit Sub
            End If
        Else
            mintNewFocus = 0
            For intX = 0 To 89
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intX), Label)
                With txtUserLetter
                    If .Visible Then
                        If .Text >= "A" And .Text <= "Z" Then
                            If Mid(mstrKey, Asc(.Text) - 64, 1) _
                            <> lblPuzzleLetter.Text Then
                                .ForeColor = Color.Red
                                If mintNewFocus = 0 Then
                                    mintNewFocus = intX
                                End If
                            End If
                        End If
                    End If
                End With
            Next
        End If

    End Sub


    Private Sub btnShowSolution_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowSolution.Click

        Dim intT As Integer
        Dim intP As Integer

        ResetForm()

        StripTheComparands()

        If mstrStrippedUserSolution = mstrStrippedPuzzle Then
            mintGamesPlayed = mintGamesPlayed + 1
            mintGamesWon = mintGamesWon + 1
            lblStatusMsg.Text = "Games Won: " & Format$(mintGamesWon) _
                              & " / Games Played: " & Format$(mintGamesPlayed)
            lblStatusMsg.Refresh()
            If MsgBox("Your solution is correct! " _
                    & "Do you want to play again?", _
                      vbYesNo + vbQuestion, "Cryptogram Message") = vbYes _
            Then
                mblnSkipCheck = True
                btnNewGame.PerformClick()
                Exit Sub
            Else
                mblnGameInProgress = False
                Me.Close()
                Exit Sub
            End If
        Else
            If MsgBox("Are you sure you want to see the solution (this " _
                    & "forfeits the game)?", _
                    vbQuestion + vbYesNo + vbDefaultButton2, _
                    "Cryptogram Message") = vbYes Then
                mintGamesPlayed = mintGamesPlayed + 1
                lblStatusMsg.Text = "Games Won: " & Format$(mintGamesWon) _
                                  & " / Games Played: " & Format$(mintGamesPlayed)
                mblnChangingViaCode = True
                intP = 0
                For intT = 0 To 89
                    txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intT), TextBox)
                    If txtUserLetter.Visible Then
                        intP = intP + 1
                        txtUserLetter.Text = Mid(mstrStrippedPuzzle, intP, 1)
                    End If
                Next
                mblnChangingViaCode = False
                btnShowSolution.Enabled = False
                btnCheck.Enabled = False
                fraMain.Enabled = False
                btnNewGame.Focus()
                mblnGameInProgress = False
                mblnSkipCheck = True
            End If
        End If

    End Sub


    Private Sub btnNewGame_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewGame.Click

        Dim blnOKToContinue As Boolean

        fraMain.Enabled = True

        If mblnSkipCheck Then
            mblnSkipCheck = False
        Else
            blnOKToContinue = CheckPreviousGameStatus()
            If Not blnOKToContinue Then
                Exit Sub
            End If
        End If

        Do
            blnOKToContinue = GetNextPuzzle()
            If blnOKToContinue Then
                CreatePuzzleKey()
                blnOKToContinue = LoadPuzzleIntoInterface()
            End If
            If Not blnOKToContinue Then
                If MsgBox(mstrErrorMessage, _
                          vbYesNo, _
                          "Cryptogram Error") = vbNo Then
                    mintLastPuzzle = mintLastPuzzle + 1
                    mblnGameInProgress = False
                    Me.Close()
                    Exit Sub
                End If
            End If
        Loop Until blnOKToContinue

        mblnGameInProgress = True
        btnCheck.Enabled = True
        btnShowSolution.Enabled = True

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Function GetControlByName(ByVal pobjParent As Control, _
                                      ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

    Private Sub LoadGameData()

        Dim strFileName As String
        Dim objFS As FileStream
        Dim objSR As StreamReader

        strFileName = My.Application.Info.DirectoryPath & "\Puzzles.txt"
        objFS = New FileStream(strFileName, FileMode.Open, FileAccess.Read)
        objSR = New StreamReader(objFS)

        mintNbrOfPuzzles = 0
        Do While objSR.Peek <> -1
            mintNbrOfPuzzles = mintNbrOfPuzzles + 1
            ReDim Preserve mastrPuzzles(mintNbrOfPuzzles - 1)
            mastrPuzzles(mintNbrOfPuzzles - 1) = objSR.ReadLine
        Loop

        objSR.Close()

        strFileName = My.Application.Info.DirectoryPath & "\LastPuzz.txt"
        objFS = New FileStream(strFileName, FileMode.Open, FileAccess.Read)
        objSR = New StreamReader(objFS)

        mintNbrOfPuzzles = 0
        Do While objSR.Peek <> -1
            mintLastPuzzle = CInt(objSR.ReadLine)
        Loop

        objSR.Close()

    End Sub


    Private Function GetRandomNumber(ByVal intLoBound As Integer, _
                                     ByVal intHiBound As Integer) _
    As Integer

        Randomize()

        GetRandomNumber = Int((intHiBound - intLoBound + 1) * Rnd() + intLoBound)

    End Function


    Private Function CheckPreviousGameStatus() As Boolean

        Dim blnPuzzleAbandoned As Boolean
        Dim intX As Integer

        For intX = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                If txtUserLetter.Text = "" Then
                    If MsgBox("The current puzzle is not yet complete. " _
                            & "Are you sure want to abandon it before " _
                            & "starting a new puzzle?", _
                               vbYesNo + vbDefaultButton2 + vbQuestion, _
                               "Cryptogram Message") = vbNo Then
                        Return False
                    End If
                    blnPuzzleAbandoned = True
                    Exit For
                End If
            End If
        Next

        If blnPuzzleAbandoned Then
            MsgBox("The solution was """ & mstrPuzzle & """", _
                   vbOKOnly, _
                   "Cryptogram Solution")
            mintGamesPlayed = mintGamesPlayed + 1
        Else
            ' check the user's solution for correctness ...
            StripTheComparands()
            If mstrStrippedUserSolution <> mstrStrippedPuzzle Then
                If MsgBox("The current puzzle is not correct. Are you " _
                        & "sure you want to abandon it before starting " _
                        & "a new puzzle?", _
                          vbYesNo + vbDefaultButton2 + vbQuestion, _
                          "Cryptogram Message") = vbNo Then
                    Return False
                Else
                    MsgBox("The solution was """ & mstrPuzzle & """", _
                           vbOKOnly, _
                           "Cryptogram Solution")
                    mintGamesPlayed = mintGamesPlayed + 1
                End If
            Else
                MsgBox("Very good!  Your solution to the last puzzle was correct!", _
                       vbOKOnly, _
                       "Cryptogram Message")
                mintGamesPlayed = mintGamesPlayed + 1
                mintGamesWon = mintGamesWon + 1
            End If
        End If

        lblStatusMsg.Text = "Games Won: " & Format$(mintGamesWon) _
                          & " / Games Played: " & Format$(mintGamesPlayed)

        Return True

    End Function


    Private Function GetNextPuzzle() As Boolean

        If mintLastPuzzle = UBound(mastrPuzzles) Then
            mintLastPuzzle = 1
        Else
            mintLastPuzzle = mintLastPuzzle + 1
        End If

        mstrPuzzle = mastrPuzzles(mintLastPuzzle)

        mintPuzzLen = Len(mstrPuzzle)

        If mintPuzzLen > 90 Then
            mstrErrorMessage = "Error: Puzzle """ _
                             & mstrPuzzle _
                             & """ exceeds 90 characters. " _
                             & "Do you want to load the " _
                             & "next available puzzle?"
            GetNextPuzzle = False
        Else
            GetNextPuzzle = True
        End If

    End Function


    Private Sub CreatePuzzleKey()

        Dim intCurrX As Integer
        Dim intCurrY As Integer
        Dim intNumX As Integer
        Dim intLetterPos As Integer
        Dim blnGoodNumber As Boolean
        Dim blnNumberAlreadyCameUp As Boolean
        Dim intNumsUsed(25) As Integer

        mstrKey = New String(" ", 26)

        For intCurrX = 1 To 26

            blnGoodNumber = True

            Do
                intLetterPos = GetRandomNumber(1, 26)
                blnNumberAlreadyCameUp = False

                For intCurrY = 1 To intCurrX
                    If intLetterPos = intNumsUsed(intCurrY - 1) Then
                        blnNumberAlreadyCameUp = True
                        Exit For
                    End If
                Next

                If intLetterPos = 26 Then
                    If blnNumberAlreadyCameUp Then
                        blnGoodNumber = False
                    Else
                        If intCurrX = 26 Then
                            Mid(mstrKey, 26, 1) = Mid(mstrKey, 1, 1)
                            Mid(mstrKey, 1, 1) = "Z"
                            Exit Do
                        Else
                            blnGoodNumber = True
                        End If
                    End If
                Else
                    If blnNumberAlreadyCameUp Then
                        blnGoodNumber = False
                    Else
                        If intLetterPos = intCurrX Then
                            blnGoodNumber = False
                        Else
                            blnGoodNumber = True
                        End If
                    End If
                End If

            Loop Until blnGoodNumber

            intNumX = intNumX + 1
            intNumsUsed(intNumX - 1) = intLetterPos
            Mid(mstrKey, intCurrX, 1) = Chr(64 + intLetterPos)

        Next

    End Sub

    Private Function LoadPuzzleIntoInterface() As Boolean

        Dim intCurrX As Integer
        Dim intPuzzPos As Integer
        Dim intScreenPos As Integer
        Dim intScreenLine As Integer
        Dim intLimit As Integer
        Dim intCharsLeft As Integer
        Dim intWordLen As Integer
        Dim intX As Integer

        Dim strPuzzChar As String
        Dim strCurrWord As String

        LoadPuzzleIntoInterface = True  ' innocent until proven guilty

        mblnChangingViaCode = True

        For intCurrX = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intCurrX), TextBox)
            txtUserLetter.ForeColor = Color.Lime
        Next

        For intCurrX = mintPuzzLen To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intCurrX), TextBox)
            lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intCurrX), Label)
            txtUserLetter.Visible = False
            lblPuzzleLetter.Visible = False
        Next

        intPuzzPos = 1
        intScreenPos = 0
        intScreenLine = 1

        Do While intPuzzPos <= mintPuzzLen

            strCurrWord = ""

            strPuzzChar = Mid(mstrPuzzle, intPuzzPos, 1)

            Do While strPuzzChar <> " " And intPuzzPos <= mintPuzzLen
                strCurrWord = strCurrWord & strPuzzChar
                intPuzzPos = intPuzzPos + 1
                strPuzzChar = Mid(mstrPuzzle, intPuzzPos, 1)
            Loop

            intWordLen = Len(strCurrWord)

            If intWordLen > 18 Then
                mstrErrorMessage = "Error: Word in puzzle """ _
                                 & mstrPuzzle _
                                 & """ exceeds 18 characters. " _
                                 & "Do you want to load the " _
                                 & "next available puzzle?"
                LoadPuzzleIntoInterface = False
                Exit Function
            End If

            intLimit = (17 * intScreenLine) + (intScreenLine - 1)
            intCharsLeft = intLimit - intScreenPos

            If intWordLen > intCharsLeft Then

                If intScreenLine = 5 Then
                    mstrErrorMessage = "Error: Puzzle """ _
                                     & mstrPuzzle _
                                     & """ does not fit into interface. " _
                                     & "Do you want to load the " _
                                     & "next available puzzle?"
                    LoadPuzzleIntoInterface = False
                    Exit Function
                End If

                Do Until intScreenPos > intLimit
                    txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intScreenPos), TextBox)
                    lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intScreenPos), Label)
                    txtUserLetter.Visible = False
                    lblPuzzleLetter.Visible = False
                    intScreenPos = intScreenPos + 1
                Loop

                intScreenLine = intScreenLine + 1
                intLimit = (17 * intScreenLine) + (intScreenLine - 1)

            End If

            For intCurrX = 1 To intWordLen
                strPuzzChar = Mid(strCurrWord, intCurrX, 1)
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intScreenPos), TextBox)
                lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intScreenPos), Label)
                If strPuzzChar >= "A" And strPuzzChar <= "Z" Then
                    With txtUserLetter
                        .Text = ""
                        .Visible = True
                        .Enabled = True
                    End With
                    With lblPuzzleLetter
                        .Text = Mid(mstrKey, Asc(strPuzzChar) - 64, 1)
                        .Visible = True
                    End With
                Else
                    With txtUserLetter
                        .Text = strPuzzChar
                        .Visible = True
                        .Enabled = True
                    End With
                    With lblPuzzleLetter
                        .Text = strPuzzChar
                        .Visible = True
                    End With
                End If
                intScreenPos = intScreenPos + 1
            Next

            If intScreenPos > intLimit Then
                intScreenLine = intScreenLine + 1
            Else
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intScreenPos), TextBox)
                lblPuzzleLetter = DirectCast(GetControlByName(fraMain, "lblPuzzleLetter" & intScreenPos), Label)
                txtUserLetter.Visible = False
                lblPuzzleLetter.Visible = False
                intScreenPos = intScreenPos + 1
                strPuzzChar = Mid(mstrPuzzle, intPuzzPos, 1)
                Do While strPuzzChar = " " And intPuzzPos <= mintPuzzLen
                    intPuzzPos = intPuzzPos + 1
                    If intPuzzPos <= mintPuzzLen Then
                        strPuzzChar = Mid(mstrPuzzle, intPuzzPos, 1)
                    End If
                Loop
            End If

        Loop

        If mblnLoadComplete Then
            For intX = 0 To 89
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    If Trim$(txtUserLetter.Text) = "" Then
                        txtUserLetter.Focus()
                        Exit For
                    End If
                End If
            Next
        End If

        mblnChangingViaCode = False

    End Function

    Private Sub StripTheComparands()

        Dim intX As Integer
        Dim strPuzzChar As String

        mstrStrippedUserSolution = ""
        For intX = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                mstrStrippedUserSolution = mstrStrippedUserSolution _
                                         & txtUserLetter.Text
            End If
        Next

        mstrStrippedPuzzle = ""
        For intX = 1 To mintPuzzLen
            strPuzzChar = Mid(mstrPuzzle, intX, 1)
            If strPuzzChar <> " " Then
                mstrStrippedPuzzle = mstrStrippedPuzzle & strPuzzChar
            End If
        Next

    End Sub

    Private Sub GoUpOrDown()

        Dim intStart As Integer
        Dim intStop As Integer
        Dim intX As Integer

        If mintNewFocus < 0 Or mintNewFocus > 89 Then Exit Sub

        mblnUpOrDown = True

        txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & mintNewFocus), TextBox)

        If Not txtUserLetter.Visible Then
            Select Case mintNewFocus
                Case 0 To 17
                    intStart = 0
                    intStop = 17
                Case 18 To 35
                    intStart = 18
                    intStop = 35
                Case 36 To 53
                    intStart = 36
                    intStop = 53
                Case 54 To 71
                    intStart = 54
                    intStop = 71
                Case Else
                    intStart = 72
                    intStop = 89
            End Select
            For intX = intStart To intStop
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & mintNewFocus), TextBox)
                If txtUserLetter.Visible Then
                    mintNewFocus = intX
                    Exit For
                End If
            Next
            If intX > intStop Then
                mblnUpOrDown = False
                Exit Sub
            End If
        End If

        txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & mintNewFocus), TextBox)
        txtUserLetter.Focus()

    End Sub

    Private Sub GoHomeOrEnd(ByVal lngKeyCode As System.Windows.Forms.Keys)

        Dim intStart As Integer
        Dim intStop As Integer
        Dim intX As Integer

        mblnHomeOrEnd = True

        Select Case mintCurrFocus
            Case 0 To 17
                intStart = 0
                intStop = 17
            Case 18 To 35
                intStart = 18
                intStop = 35
            Case 36 To 53
                intStart = 36
                intStop = 53
            Case 54 To 71
                intStart = 54
                intStop = 71
            Case Else
                intStart = 72
                intStop = 89
        End Select

        If lngKeyCode = Keys.Home Then
            For intX = intStart To intStop
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    mintNewFocus = intX
                    Exit For
                End If
            Next
        Else
            For intX = intStop To intStart Step -1
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    mintNewFocus = intX
                    Exit For
                End If
            Next
        End If

        txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & mintNewFocus), TextBox)
        txtUserLetter.Focus()

    End Sub

    Private Sub CheckForAllBlanks()

        Dim intX As Integer

        mblnAllBlank = True
        For intX = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            If txtUserLetter.Visible Then
                If Trim(txtUserLetter.Text) >= "A" _
                And Trim(txtUserLetter.Text) <= "Z" Then
                    mblnAllBlank = False
                    Exit For
                End If
            End If
        Next

    End Sub

    Private Sub ResetForm()

        Dim intX As Integer

        For intX = 0 To 89
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
            With txtUserLetter
                If .Visible Then
                    If (.Text >= "A" And .Text <= "Z") _
                    Or Trim$(.Text) = "" Then
                        .ForeColor = Color.Lime
                    End If
                End If
            End With
        Next

        btnCheck.Enabled = True


    End Sub

    Private Sub ResetFocus()

        Dim intX As Integer

        If mintNewFocus = 0 Then
            For intX = 0 To 89
                txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & intX), TextBox)
                If txtUserLetter.Visible Then
                    If Trim(txtUserLetter.Text) = "" Then
                        txtUserLetter.Focus()
                        Exit For
                    End If
                End If
            Next
        Else
            txtUserLetter = DirectCast(GetControlByName(fraMain, "txtUserLetter" & mintNewFocus), TextBox)
            txtUserLetter.Focus()
        End If

    End Sub

End Class